diff -uwbBpr libfloat/softfloat/bits64/softfloat.c SoftFloat-2a/softfloat/bits64/softfloat.c
--- libfloat/softfloat/bits64/softfloat.c	Wed Sep 15 16:18:52 1999
+++ SoftFloat-2a/softfloat/bits64/softfloat.c	Mon Sep 20 11:47:08 1999
@@ -4624,38 +5086,33 @@ float128 float128_sqrt( float128 a )
     zExp = ( ( aExp - 0x3FFF )>>1 ) + 0x3FFE;
     aSig0 |= LIT64( 0x0001000000000000 );
     zSig0 = estimateSqrt32( aExp, aSig0>>17 );
-    zSig0 <<= 31;
     shortShift128Left( aSig0, aSig1, 13 - ( aExp & 1 ), &aSig0, &aSig1 );
-    zSig0 = estimateDiv128To64( aSig0, aSig1, zSig0 ) + zSig0 + 4;
-    if ( 0 <= (sbits64) zSig0 ) zSig0 = LIT64( 0xFFFFFFFFFFFFFFFF );
-    shortShift128Left( aSig0, aSig1, 2, &aSig0, &aSig1 );
+    zSig0 = estimateDiv128To64( aSig0, aSig1, zSig0<<32 ) + ( zSig0<<30 );
+    doubleZSig0 = zSig0<<1;
     mul64To128( zSig0, zSig0, &term0, &term1 );
     sub128( aSig0, aSig1, term0, term1, &rem0, &rem1 );
     while ( (sbits64) rem0 < 0 ) {
         --zSig0;
-        shortShift128Left( 0, zSig0, 1, &term0, &term1 );
-        term1 |= 1;
-        add128( rem0, rem1, term0, term1, &rem0, &rem1 );
-    }
-    shortShift128Left( rem0, rem1, 63, &shiftedRem0, &shiftedRem1 );
-    zSig1 = estimateDiv128To64( shiftedRem0, shiftedRem1, zSig0 );
-    if ( ( zSig1 & 0x3FFF ) <= 5 ) {
+        doubleZSig0 -= 2;
+        add128( rem0, rem1, zSig0>>63, doubleZSig0 | 1, &rem0, &rem1 );
+    }
+    zSig1 = estimateDiv128To64( rem1, 0, doubleZSig0 );
+    if ( ( zSig1 & 0x1FFF ) <= 5 ) {
         if ( zSig1 == 0 ) zSig1 = 1;
-        mul64To128( zSig0, zSig1, &term1, &term2 );
-        shortShift128Left( term1, term2, 1, &term1, &term2 );
+        mul64To128( doubleZSig0, zSig1, &term1, &term2 );
         sub128( rem1, 0, term1, term2, &rem1, &rem2 );
         mul64To128( zSig1, zSig1, &term2, &term3 );
         sub192( rem1, rem2, 0, 0, term2, term3, &rem1, &rem2, &rem3 );
         while ( (sbits64) rem1 < 0 ) {
             --zSig1;
-            shortShift192Left( 0, zSig0, zSig1, 1, &term1, &term2, &term3 );
+            shortShift128Left( 0, zSig1, 1, &term2, &term3 );
             term3 |= 1;
-            add192(
-                rem1, rem2, rem3, term1, term2, term3, &rem1, &rem2, &rem3 );
+            term2 |= doubleZSig0;
+            add192( rem1, rem2, rem3, 0, term2, term3, &rem1, &rem2, &rem3 );
         }
         zSig1 |= ( ( rem1 | rem2 | rem3 ) != 0 );
     }
-    shift128ExtraRightJamming( zSig0, zSig1, 0, 15, &zSig0, &zSig1, &zSig2 );
+    shift128ExtraRightJamming( zSig0, zSig1, 0, 14, &zSig0, &zSig1, &zSig2 );
     return roundAndPackFloat128( 0, zExp, zSig0, zSig1, zSig2 );
 
 }
@@ -4664,7 +5121,7 @@ float128 float128_sqrt( float128 a )
 -------------------------------------------------------------------------------
 Returns 1 if the quadruple-precision floating-point value `a' is equal to
 the corresponding value `b', and 0 otherwise.  The comparison is performed
-according to the IEC/IEEE Standard for Binary Floating-point Arithmetic.
+according to the IEC/IEEE Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 flag float128_eq( float128 a, float128 b )
@@ -4694,7 +5151,7 @@ flag float128_eq( float128 a, float128 b
 -------------------------------------------------------------------------------
 Returns 1 if the quadruple-precision floating-point value `a' is less than
 or equal to the corresponding value `b', and 0 otherwise.  The comparison
-is performed according to the IEC/IEEE Standard for Binary Floating-point
+is performed according to the IEC/IEEE Standard for Binary Floating-Point
 Arithmetic.
 -------------------------------------------------------------------------------
 */
@@ -4728,7 +5185,7 @@ flag float128_le( float128 a, float128 b
 -------------------------------------------------------------------------------
 Returns 1 if the quadruple-precision floating-point value `a' is less than
 the corresponding value `b', and 0 otherwise.  The comparison is performed
-according to the IEC/IEEE Standard for Binary Floating-point Arithmetic.
+according to the IEC/IEEE Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 flag float128_lt( float128 a, float128 b )
@@ -4762,7 +5219,7 @@ flag float128_lt( float128 a, float128 b
 Returns 1 if the quadruple-precision floating-point value `a' is equal to
 the corresponding value `b', and 0 otherwise.  The invalid exception is
 raised if either operand is a NaN.  Otherwise, the comparison is performed
-according to the IEC/IEEE Standard for Binary Floating-point Arithmetic.
+according to the IEC/IEEE Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 flag float128_eq_signaling( float128 a, float128 b )
@@ -4790,7 +5247,7 @@ flag float128_eq_signaling( float128 a, 
 Returns 1 if the quadruple-precision floating-point value `a' is less than
 or equal to the corresponding value `b', and 0 otherwise.  Quiet NaNs do not
 cause an exception.  Otherwise, the comparison is performed according to the
-IEC/IEEE Standard for Binary Floating-point Arithmetic.
+IEC/IEEE Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 flag float128_le_quiet( float128 a, float128 b )
@@ -4827,7 +5284,7 @@ flag float128_le_quiet( float128 a, floa
 Returns 1 if the quadruple-precision floating-point value `a' is less than
 the corresponding value `b', and 0 otherwise.  Quiet NaNs do not cause an
 exception.  Otherwise, the comparison is performed according to the IEC/IEEE
-Standard for Binary Floating-point Arithmetic.
+Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 flag float128_lt_quiet( float128 a, float128 b )
Only in libfloat/softfloat/bits64/templates: CVS
